/*
 * hex.c : pYuwbNXv 15 pY̕ό`o[W
 *
 */
/*
   ԂԎ萔̂Ԃ߂
   O󂫏ꏊ\

         P------Q
       ^  _  ^  _
     R------S------T
       _  ^  _  ^ 
         U------O

W
         O------P
       ^  _  ^  _
     Q------R------S
       _  ^  _  ^ 
         T------U
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define TRUE  1
#define FALSE 0
#define SIZE  7

/* ő̏Ԑ 7! = 5040 */
#define MAX_STATE 5040

/* אڃXg */
const char adjacent[SIZE][7] = {
  1, 2, 3, -1, -1, -1, -1,  /* 0 */
  0, 3, 4, -1, -1, -1, -1,  /* 1 */
  0, 3, 5, -1, -1, -1, -1,  /* 2 */
  0, 1, 2,  4,  5,  6, -1,  /* 3 */
  1, 3, 6, -1, -1, -1, -1,  /* 4 */
  2, 3, 6, -1, -1, -1, -1,  /* 5 */
  3, 4, 5, -1, -1, -1, -1   /* 6 */
};

/* L[ */
char state[MAX_STATE + 1][SIZE];     /* +1 ̓[N̈ */
char space_postion[MAX_STATE];
char move[MAX_STATE];

/*  */
char init_state[SIZE] = {
  1, 2, 3, 4, 5, 6, 0
};

int count = 0;

/* Ԃ邩 */
int check_same_state( int n )
{
  int i;
  for( i = 0; i < n; i++ ){
    count++;
    if( !memcmp( state[i], state[n], SIZE ) ) return TRUE;
  }
  return FALSE;
}

/* ʂo */
void print_answer( int n )
{
  int m = move[n - 1], c = 0, i;
  while( move[--n] == m ){
    c++;
    for( i = 0; i < SIZE; i++ ){
      printf("%d ", state[n][i] );
    }
    printf("\n");
  }
  printf("Œ萔 %d A %d \n", m, c );
}

void print_answer_all( int n )
{
  int i, j;
  for( j = 0; j < n; j++ ){
    printf("萔 %d : ", move[j] );
    for( i = 0; i < SIZE; i++ ){
      printf("%d ", state[j][i] );
    }
    printf("\n");
  }
}

/* T */
void search( void )
{
  int front = 0, rear = 1, i;
  /*  */
  memcpy( state[0], init_state, SIZE );
  space_postion[0] = 6;
  move[0] = 0;
  while( front < rear ){
    int s = space_postion[front];
    int n;
    for( i = 0; (n = adjacent[s][i]) != -1; i++ ){
      /* ԂRs[ */
      memcpy( state[rear], state[front], SIZE );
      /* ړ */
      state[rear][s] = state[rear][n];
      state[rear][n] = 0;
      if( !check_same_state( rear ) ){
	/* o^ */
	space_postion[rear] = n;
	move[rear] = move[front] + 1;
	rear++;
      }
    }
    front++;
  }
  print_answer( rear );
}

int main()
{
  int start, end;
  start = clock();
  search();
  end = clock();
  printf("r %d A %d \n", count, end - start );
  return 0;
}

/* end of file */

